// Floyd's Algorithm in C

#include <stdlib.h>
#include <stdio.h>
#include "mpi.h"

#define N 3200
#define MAX 1000
#define MODUL 100
#define CAMINS ((N*N)/3)

int m[N][N];
int  suma[N];


main(int num_args, char* args[])
{
 int i,j,k,fila,rank,p,x,y;
 long long s;

//inicialitzacions MPI
MPI_Init(&num_args,&args);
MPI_Comm_rank(MPI_COMM_WORLD,&rank);
MPI_Comm_size(MPI_COMM_WORLD,&p);


int acumulador[N/p];

//inicialització de la matriu
    for ( i = 0; i < N; i++ )
        for ( j = 0; j < N; j++ )
            m[i][j] = MAX;

    for ( k = 0 ; k < CAMINS ; k++)
      {
        i = rand()%N;
        j = rand()%N;
        m[i][j] = m[j][i] = rand()%MODUL +1;
      }

    for ( i = 0; i < N; i++ )
        m[i][i] = 0;

        for(k =0; k < N; k++){

                fila=k%p;
                MPI_Bcast(m[k], N, MPI_INT, fila, MPI_COMM_WORLD);

                for(i=rank;i<N;i+=p){
                        for(j=0; j < N; j++)
                                if(m[k][i] + m[k][j]< m[i][j])
                                        m[i][j] = m[k][i] + m[k][j];
                }
        }

        y = 0;
        for (x=rank;x<N;x+=p){
                acumulador[y] = 0;
                for (j=x+1; j<N; j++)
                        acumulador[y] += m[x][j];
                y++;
        }

        MPI_Gather(&acumulador, (N/p), MPI_INT, &suma, (N/p), MPI_INT, 0, MPI_COMM_WORLD);


if (rank==0){
    s = 0;
  for (i=0; i<N/p; i++)
   {
    for (x=i;x<N;x+=N/p){
    printf("  %ld \n ", suma[x]);
    s +=suma[x];
}
   }
 printf("Suma %ld \n ",s);
}
    MPI_Finalize();
}

